/***************************************************************************
 *   Copyright (C) 2004 by Janos Horvath                                   *
 *   bourne@freemail.hu                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CALLBACKS_H
#define CALLBACKS_H

extern "C"
{
    #include <lua.h>
}

int _SendDataToUser(lua_State *);
int _SendDataToAll(lua_State *);
int _SendPMToAll(lua_State *);
int _CloseConnection(lua_State *);
int _GetMyINFO(lua_State *);
int _GetUserClass(lua_State *);
int _GetUserHost(lua_State *);
int _GetUserIP(lua_State *);
int _GetNickList(lua_State *);
int _Ban(lua_State *);
int _KickUser(lua_State *);
int _ParseCommand(lua_State *);
int _SetConfig(lua_State *);
int _GetConfig(lua_State *);

int _AddRobot(lua_State *);
int _DelRobot(lua_State *);

int _SQLQuery(lua_State *);
int _SQLFetch(lua_State *);
int _SQLFree(lua_State *);

int _GetUsersCount(lua_State *L);
int _GetTotalShareSize(lua_State *L);

void luaerror(lua_State *, const char *);

#endif
